## Copyright (C) 2020 by University of Luxembourg

## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at

##     http://www.apache.org/licenses/LICENSE-2.0

## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.


##' @import data.table
## Redirections
the_ifelse <- data.table::fifelse
dtable <- data.table::data.table

tab2file<-function(tab,file,...) {
    data.table::fwrite(x=tab,file=file,...)
}

file2tab<-function(file,na.strings=c("","NA"),...) {
    data.table::fread(file=file,na.strings = na.strings, ...)
}

isThingFile<-function(fn) {
    if (length(fn)>0 && is.character(fn)) {
        file.exists(fn)
    } else F
}

## Stolen from Stack Overflow
split_path <- function(path) {
  if (dirname(path) %in% c(".", path)) return(basename(path))
  return(c(basename(path), split_path(dirname(path))))
}


print_table <- function (df) {
    paste(apply(df,1,function (row) paste(row,collapse=',')),collapse = "\n")
}

assert <- function(expr,msg) shiny::validate(shiny::need(expr,message=msg))
